/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.ejb;

import java.rmi.RemoteException;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import org.jbpm.pvm.internal.env.Authentication;
import org.ow2.bonita.facade.Context;
import org.ow2.bonita.facade.QueryRuntimeAPI;
import org.ow2.bonita.facade.ejb.ejb2.internal.EJB2InternalQueryRuntimeAPI;
import org.ow2.bonita.facade.impl.StandardAPIAccessorImpl;
import org.ow2.bonita.util.AccessorUtil;

/**
 * @author Pierre Vigneras, Charles Souillard, Guillaume Porcher
 * @date Feb 15, 2008
 */
public class QueryRuntimeAPIBean extends EJB2InternalQueryRuntimeAPI implements SessionBean {

  protected SessionContext ctx = null;

  protected QueryRuntimeAPI queryRuntimeAPI;

  protected QueryRuntimeAPI getAPI() {
    Authentication.setUserId(ctx.getCallerPrincipal().getName());
    // IMPORTANT Note: see AccessorUtil.setContext() 
    AccessorUtil.setContext(Context.Standard);
    if (queryRuntimeAPI == null) {
      queryRuntimeAPI = new StandardAPIAccessorImpl().getQueryRuntimeAPI();
    }
    return queryRuntimeAPI;
  }


  public void ejbCreate() {
  }

  public void ejbActivate() throws RemoteException {

  }

  public void ejbPassivate() throws RemoteException {

  }

  public void ejbRemove() throws RemoteException {

  }

  public void setSessionContext(SessionContext arg0) throws RemoteException {
    this.ctx = arg0;
  }
}


