package org.ow2.bonita.facade.ejb.ejb2.internal;

import java.net.URL;
import java.util.Map;
import java.util.Set;

import org.ow2.bonita.deployment.Deployment;
import org.ow2.bonita.facade.ManagementAPI;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition;
import org.ow2.bonita.facade.exception.DeploymentException;
import org.ow2.bonita.facade.exception.PackageNotFoundException;
import org.ow2.bonita.facade.exception.UndeletableInstanceException;
import org.ow2.bonita.facade.exception.UndeletablePackageException;
import org.ow2.bonita.facade.uuid.PackageDefinitionUUID;
import org.ow2.bonita.util.EJBUtil;

public class EJB2InternalManagementAPI implements ManagementAPI {

  protected ManagementAPI getAPI() {
    return EJBUtil.getEJB2APIAccessor().getManagementAPI();
  }


  public Map<String, ProcessDefinition> deploy(Deployment deployment) throws DeploymentException {
    return getAPI().deploy(deployment);
  }

  public Map<String, ProcessDefinition> deployBar(URL barFileURL) throws DeploymentException {
    return getAPI().deployBar(barFileURL);
  }

  public Map<String, ProcessDefinition> deployBar(byte[] barFile) throws DeploymentException {
    return getAPI().deployBar(barFile);
  }

  public void deployClass(byte[] clazz) throws DeploymentException {
    getAPI().deployClass(clazz);
  }
  public void deployClasses(Set<byte[]> classes) throws DeploymentException {
    getAPI().deployClasses(classes);
  }
  public void deployClassesInJar(byte[] classesArchive) throws DeploymentException {
    getAPI().deployClassesInJar(classesArchive);
  }
  public void undeploy(PackageDefinitionUUID packageUUID) throws DeploymentException {
    getAPI().undeploy(packageUUID);
  }
  public void removeClass(String className) throws DeploymentException {
    getAPI().removeClass(className);
  }
  public void removeClasses(String[] classNames) throws DeploymentException {
    getAPI().removeClasses(classNames);
  }
  public void replaceClass(String className, byte[] newClazz) throws DeploymentException {
    getAPI().replaceClass(className, newClazz);
  }
  public void clearHistory() {
    getAPI().clearHistory();
  }
  public Map<String, ProcessDefinition> deploy(URL xpdlURL, Class< ? >[] classes) throws DeploymentException {
    return getAPI().deploy(xpdlURL, classes);
  }
  public Map<String, ProcessDefinition> deployXpdl(URL xpdlURL) throws DeploymentException {
    return getAPI().deployXpdl(xpdlURL);
  }
  public Map<String, ProcessDefinition> deployXpdl(byte[] xpdlFile) throws DeploymentException {
    return getAPI().deployXpdl(xpdlFile);
  }
  public Map<String, ProcessDefinition> deployZip(byte[] zipFile) throws DeploymentException {
    return getAPI().deployZip(zipFile);
  }
  public Map<String, ProcessDefinition> deployZip(URL zipURL) throws DeploymentException {
    return getAPI().deployZip(zipURL);
  }
  public void deletePackage(PackageDefinitionUUID pacDefinitionUUID)
    throws PackageNotFoundException, UndeletablePackageException, UndeletableInstanceException {
    getAPI().deletePackage(pacDefinitionUUID);
  }
}
