/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.impl;

import java.lang.reflect.Proxy;

import org.ow2.bonita.facade.APIAccessor;
import org.ow2.bonita.facade.APIInterceptor;
import org.ow2.bonita.facade.CommandAPI;
import org.ow2.bonita.facade.DefinitionAPI;
import org.ow2.bonita.facade.ManagementAPI;
import org.ow2.bonita.facade.RuntimeAPI;

public class StandardAPIAccessorImpl extends QueryAPIAccessorImpl implements APIAccessor {

  public RuntimeAPI getRuntimeAPI() {
    Class<RuntimeAPI> clazz = RuntimeAPI.class;
    APIInterceptor apiInterceptor = new APIInterceptor(new RuntimeAPIImpl());
    return (RuntimeAPI) Proxy.newProxyInstance(APIAccessor.class.getClassLoader(),
        new Class[] {clazz}, apiInterceptor);
  }

  public ManagementAPI getManagementAPI() {
    Class<ManagementAPI> clazz = ManagementAPI.class;
    APIInterceptor apiInterceptor = new APIInterceptor(new ManagementAPIImpl());
    return (ManagementAPI) Proxy.newProxyInstance(APIAccessor.class.getClassLoader(),
        new Class[] {clazz}, apiInterceptor);
  }

  public DefinitionAPI getDefinitionAPI() {
    Class<DefinitionAPI> clazz = DefinitionAPI.class;
    APIInterceptor apiInterceptor = new APIInterceptor(new DefinitionAPIImpl());
    return (DefinitionAPI) Proxy.newProxyInstance(APIAccessor.class.getClassLoader(),
        new Class[] {clazz}, apiInterceptor);
  }

  public CommandAPI getCommandAPI() {
    Class<CommandAPI> clazz = CommandAPI.class;
    APIInterceptor apiInterceptor = new APIInterceptor(new CommandAPIImpl());
    return (CommandAPI) Proxy.newProxyInstance(APIAccessor.class.getClassLoader(),
        new Class[] {clazz}, apiInterceptor);
  }

}


